// Lawson Labs, Inc.
// 3217 Phoenixville Pike
// Malvern, PA  19355
// 800 321-5355 or 406 257-5355             
// 6-13-18
// filename: NT_m201

//6-13-18 replaced clrscr() macro with system("cls") since
//	macro did not work in Win10

#include <windows.h>
#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include "NTm201ax.h"
 
//#define dbgMSG_BOX(_msg_) MessageBox(0, _msg_, "timMSG", MB_OK); 
#define dbgMSG_BOX(_msg_)


//HANDLE	hOutCon, hInCon, hLibM201;
HMODULE  hLibM201;
HANDLE   hOutCon, hInCon;
COORD	pos, dwCursorPosition;
CONSOLE_CURSOR_INFO	ConsoleCursorInfo;
CONSOLE_SCREEN_BUFFER_INFO lpConsoleScreenBufferInfo;
DWORD	lpNumberOfCharsWritten;

// following macro allows use of gotoxy and clrscr 
// functions used by previous 16-bit and Win32s code
#define gotoxy(x, y) pos.X = x; pos.Y = y - 1;	\
SetConsoleCursorPosition(hOutCon, pos);
/* prior to 6-13-18. Did not work in Win10 so replaced with 
	system("cls")
#define clrscr() pos.X = 0; pos.Y = 0;		\
FillConsoleOutputCharacter(hOutCon, ' ',	\
80*25, pos, &lpNumberOfCharsWritten);
*/

//T_M201  M201;  

T_M201 *pM201[256];

int			cc[6];
int startCC, endCC; 
int n2;

BYTE bIndex = 0;		//Current used device index

bool bSignOnDone[256];		//temp variable to avoid re-signon


const M201_NUM = 4;

void init_instance(BYTE bTotalDev)
{
	/*In this function, you are about assign init value
	  Assign ports to each device. if the configuration
	  needs to be saved into disk, you need to write function
	  to deal with multiple device configuration saving structure
	  
	  Since the COM port can be changed from the menu, you need to
	  check if new COM port are used by other device, if so, it may
	  cause error
	*/
	BYTE i;

	for(i = 0; i < bTotalDev; i++){
		pM201[i] = new T_M201;
		pM201[i]->comPort = i;			//auto assign from COM1 to COMn
										// this doesn't has to be in order
		pM201[i]->standBy = 0;			//set to not in standby
		pM201[i]->sleeping = 0;			//set to awake
		bSignOnDone[i] = FALSE;
	}
}

int __cdecl main(void)
{

  char myBuff[1024];
  sprintf(myBuff, "Please read:\n\n"
			"This version of our console application is designed for developers. However, it can also"
			" be used by non-developers by understanding a few issues that are done automatically in some"
			" of our other sample applications, but not by this one.\n\n"
			" For example, the COM port setting will always load with COM1 regardless of what has been saved"
			" in the configuration file. Also, although the application is designed for handling up to 256"
			" COM ports, that option is only available through addtional changes to the source code by a"
			" software developer.");
  MessageBox(GetForegroundWindow(), myBuff, "NOTICE --- This is not an error or warning, but please read.", MB_OK);


	//3-11-02 ########################
	int received = 0, scanWords;
	BOOLEAN fQuickExitScan = FALSE;
	//3-11-02 ########################

	init_instance(M201_NUM);			//for example, 2 devices are init.
								//Up to 256 devices can be assigned
	FILE		*out;
	long rawCount, scanCnt;

	int 		i,n,p_row = 14,logging, ccode,Ch;


	double 		voltage, max=-12000, min=12000;
	char 		fileName[12], tmpbuf[80];;
	short		receiveError, localAvg=1, checkSum = 1;
	int			tempCh, tempSub;  // timtest

	short 		bauds[]={  //  table for baud rate codes
								/* 0 */  9600,
								/* 1 */  4800,
								/* 2 */  2400,
								/* 3 */  1200,
								/* 4 */   600,
								/* 5 */   300};
	//variables for standard deviation calculation
	double		stDv=0, rmsBits=0, sdTot = 0, runningAvg=0, sd[41];;
	int    		sdCount=1;
	pM201[bIndex]->timeBaseCnt = -1;

	//if(long(1) > 1) MessageBox(0, "test", "", 0);

	//dbgMSG_BOX("test");

	hOutCon = GetStdHandle(STD_OUTPUT_HANDLE);
	if(!hOutCon)
	{
		MessageBox(0, "Error writing to console", "-- error", MB_OK);
		return 1;
	}
	hInCon =  GetStdHandle(STD_INPUT_HANDLE);
	if(!hInCon)
	{
		MessageBox(0, "Error reading from console", "-- error", MB_OK);
		return 1;
	}

	ConsoleCursorInfo.dwSize=1;
	ConsoleCursorInfo.bVisible = TRUE;

	if(!LoadLibraries())
		exit(1);

	if(!CheckLibFuncs())
	{
		UnloadLibraries();
		exit(1);
	}

	///Add multi board config reload Feb 5.2001
	for( bIndex = 0; pM201[bIndex]; bIndex++){
		if (!ReadConfig(&localAvg))
		{
		  gotoxy(24,10);
		  printf("unable to read 201EWIN.CFG file");
		  gotoxy(26,11);
		  printf("press any key to continue");
		  getch();
		}
		pM201[bIndex]->comPort = bIndex;//temp assign,could be any number
	}
	bIndex = 0;

#if 0
	if(!SetPtrs(pM201, pNewScanBuff))
	{
		MessageBox(0, "Could not set required pointers\n"
					"  between application and DLL", "-- error", MB_OK);
		UnloadLibraries();
		exit(1);
	}
#endif

	pM201[bIndex]->standBy = 0;			//set to not in standby
	pM201[bIndex]->sleeping = 0;			//set to awake


TOP_MENU:

  Ch = 0;

  while(Ch != 27)
  {
	 system("cls");  //6-13-18 replaces clrscr() macro
	 gotoxy(22,4);
	 printf ("MODEL 201 Data Acquisition System");
	 gotoxy(34,6);
	 printf ("Main Menu");
	 gotoxy(20,8);
	 printf ("1) Baud rate          %4d",bauds[pM201[bIndex]->baud]);
	 gotoxy(20,10);
	 printf ("2) Serial port        COM%d",pM201[bIndex]->comPort+1);
	 gotoxy(20,12);
	 printf ("3) Input buffer     %6d bytes",pM201[bIndex]->RXQUEUESIZE);
	 gotoxy(20,14);
	 printf ("4) Polled Mode");
	 gotoxy(20,16);
	 printf ("5) Scanning Mode");
	 gotoxy(18,18);
	 printf ("Esc) Exit program");

	 if (pM201[bIndex]->sleeping)
	 {
		gotoxy(20,20);
		printf("Model 201 is in sleep mode");
	 }

	 Ch = getch();
	

	 if (Ch == 27)
	 {
		goto EXIT_POINT;
	 }

	 if (Ch == '1')
	 {

		if (pM201[bIndex]->baud++ == 5)
		{
		  pM201[bIndex]->baud = 0;
		}

	 }
	 if (Ch == '2')
	 {
		 bIndex ++;
		 if(bIndex >=M201_NUM){
			 bIndex = 0;
		 }

#if 0
		if (pM201[bIndex]->comPort++ == 3)
		{
		  pM201[bIndex]->comPort = 0;
		}
#endif

	 }
	 if (Ch == '3')
	 {
		system("cls");  //6-13-18 replaces clrscr() macro
		SetWin32CursorOn();
		gotoxy (14,12);
		printf("(enter between 11 and 32767)");
		gotoxy(15,10);
		printf("Enter size of input buffer  ");
		getch();    
		fgets(tmpbuf,80,stdin);
		sscanf(tmpbuf,"%d",&pM201[bIndex]->RXQUEUESIZE);
		SetWin32CursorOff();

		if (pM201[bIndex]->RXQUEUESIZE < 11)
		{
			pM201[bIndex]->RXQUEUESIZE = 11;
		}

	 }

	 if (Ch == '4')
	 {
		pM201[bIndex]->sleeping = 0;
		system("cls");  //6-13-18 replaces clrscr() macro
		gotoxy(30,12);
		printf("Signing on at COM%d",pM201[bIndex]->comPort + 1);

		if (!SignOn(pM201[bIndex]))
		{
		  gotoxy(16,14);
		  printf ("unable to sign on.  Press any key to continue");
		  getch();
		  goto TOP_MENU;
		}
		GetComHandle(pM201[bIndex],&IdComDev);		//get handle to comm port

		gotoxy(20,12);
		printf("Performing system calibration...");
		if(!SysCal(pM201[bIndex])){
		  gotoxy(16,14);
		  printf ("unable to do Syscal.  Press any key to continue");
		  getch();
		  goto TOP_MENU;
		}

		GetVer(pM201[bIndex]);			//get version
		RemoteAvg(pM201[bIndex]);		//set averaging
		SetChanCode(pM201[bIndex]);		//set channel and subchannel

		FilterDelay(pM201[bIndex]);	//wait filter settling time
		bSignOnDone[bIndex] = TRUE;
		goto POLLED;
	 }

	 if (Ch == '5')
	 {
		system("cls");  //6-13-18 replaces clrscr() macro
		goto GET_SCANS;
	 }

  } //while Ch != 27

goto EXIT_POINT;

POLLED:

  system("cls");  //6-13-18 replaces clrscr() macro
  gotoxy(1, 1);
  PrintCommandMenu(Ch, localAvg, checkSum);
  //Multi boards
  while (Ch != 27)			//repeat until esc key pressed or an error
  {

	 while (!kbhit() && !pM201[bIndex]->standBy)//loop until keyboard hit
	 {
		gotoxy(1,p_row++);

		voltage = 0;
		rawCount = 0;

		for (i=0;i<localAvg;i++)
		{
		  if(!GetConversion(pM201[bIndex]))
		  {
			 gotoxy(1,23);
			 printf("get conversion failed, press any key to continue");
			 printf("\n       %X       ",pM201[bIndex]->errorType);
			 while (Ch != 27)
			 {
				Ch = getch();
			 }

			 goto TOP_MENU;
		  }

		  voltage += pM201[bIndex]->voltage;
		  rawCount += pM201[bIndex]->rawCount;
		}
		pM201[bIndex]->voltage = voltage/localAvg;
		pM201[bIndex]->rawCount = rawCount/localAvg;

		printf ("   %9ld     %9.3lf",pM201[bIndex]->rawCount,pM201[bIndex]->voltage);

		if (max < pM201[bIndex]->voltage)
		{
		  max = pM201[bIndex]->voltage;               //update maximum
		}

		if (min > pM201[bIndex]->voltage)
		{
		  min = pM201[bIndex]->voltage;               //update minimum
		}

		StandardDev(&stDv, &rmsBits, &sdTot,
					&runningAvg, sd, &sdCount);

		if (p_row == 23)
		{
		  p_row = 14;
		  gotoxy(40,14);
		  printf ("Maximum     %9.3lf mv       ", max);
		  gotoxy (40,15);
		  printf ("Minimum     %9.3lf mv       ", min);
		  gotoxy (40,16);
		  printf ("Delta       %9.3lf mv       ", fabs(max - min));
		  gotoxy (40,17);
		  printf ("Average     %9.3lf mv       ", runningAvg);
		  gotoxy (40,19);
		  printf ("Standard deviation  %9.3lf mv    ", stDv);
		  gotoxy (40,20);
		  printf ("Effective Resolution  %5.1lf   bits", rmsBits);
		  gotoxy (1,14);
		}

	 }   //while (!kbhit()  && !pM201[bIndex]->standBy)

	 Ch = getch();

	 if (Ch != 27)
	 {

		if (islower(Ch))
		{
		  Ch = toupper(Ch);
		}

		if (Ch == 'C' || Ch == 'E' || Ch == 'G' || Ch == 'P' || Ch == 'W')
		{
		  stDv=0; rmsBits=0; sdTot = 0; runningAvg=0; sdCount=1;
		}
		DoCommand(Ch, &max, &min, &localAvg, &checkSum);
	  if (Ch == 'X')
	  {
		 SetWin32CursorOn();
		tempCh = 0;
		 while (!tempCh || pM201[tempCh] == NULL)
		 {
			gotoxy(1,24);
			printf("                                                          ");
			gotoxy(1,24);
			printf ("Enter COM(1-4)");
			getch();    
			fgets(tmpbuf,80,stdin);
			tempCh = atoi(tmpbuf);
		 }
		bIndex = tempCh - 1;
		SetWin32CursorOff();
		//change M201 board
		if(!bSignOnDone[bIndex]){
				pM201[bIndex]->sleeping = 0;
				system("cls");  //6-13-18 replaces clrscr() macro
				gotoxy(30,12);
				printf("Signing on at COM%d",pM201[bIndex]->comPort + 1);
				if (!SignOn(pM201[bIndex])){
				  gotoxy(16,14);
				  printf ("unable to sign on.  Press any key to continue");
				  getch();
				  goto TOP_MENU;
				}
				GetComHandle(pM201[bIndex],&IdComDev);		//get handle to comm port
				gotoxy(20,12);
				printf("Performing system calibration...");
				if(!SysCal(pM201[bIndex])){
				  gotoxy(16,14);
				  printf ("unable to do Syscal.  Press any key to continue");
				  getch();
				  goto TOP_MENU;
				}
				GetVer(pM201[bIndex]);			//get version
				RemoteAvg(pM201[bIndex]);		//set averaging
				SetChanCode(pM201[bIndex]);		//set channel and subchannel
				FilterDelay(pM201[bIndex]);	//wait filter settling time
				bSignOnDone[bIndex] = TRUE;
		}
		goto POLLED; //don't resign on
	  }
	 }
	 if (pM201[bIndex]->sleeping)
	 {
		goto TOP_MENU;
	 }

  }	//while (Ch != 27)

  goto TOP_MENU;			//end of polled mode example


GET_SCANS:					//start of scanned mode example
  tempCh = pM201[bIndex]->channel;	//hold values for current channel and subchannel
  tempSub = pM201[bIndex]->subChan;

  if (!ScanMenu())			//setup scanning details
  {
	 goto TOP_MENU;
  }

  pM201[bIndex]->sleeping = 0;
  system("cls");  //6-13-18 replaces clrscr() macro
  gotoxy(30,12);
  printf("Signing on at COM%d",pM201[bIndex]->comPort + 1);
  if (!SignOn(pM201[bIndex]))			//signon again with new scanning details
  {
	 gotoxy(16,14);
	 printf ("unable to sign on.  Press any key to continue");
	 getch();
	 goto TOP_MENU;
  }

  GetComHandle(pM201[bIndex],&IdComDev);	//get handle to comm port

  gotoxy(20,12);
  printf("Performing system calibration...");
  SysCal(pM201[bIndex]);

  RemoteAvg(pM201[bIndex]);

  system("cls");  //6-13-18 replaces clrscr() macro

  logging = 0;

  SetWin32CursorOn();
  gotoxy(20,13);
  printf("Enter name for disk file,");
  gotoxy(20,15);
  printf("or just enter for no file ");
  //12-5-02 getch();   
  gets(fileName);
  SetWin32CursorOff();

  if (strlen(fileName))
  {
	 logging = 1;
  }

  if(logging)
  {
	 if ((out = fopen(fileName, "at"))== NULL)
	 {
		gotoxy(20,19);
		printf("Could not open/create file\n");
		goto END_SCANS;
	 }
  }
  pM201[bIndex]->numChannels = 0;

  for (n= 0;n<=5;n++)				//initialize control code array
  {
	 cc[n] = (pM201[bIndex]->chan[n] & 0x0f) - (pM201[bIndex]->chan[n]>>4) + 1;  // timtest
	 pM201[bIndex]->numChannels += cc[n];		//figure total number of channels/scan
  }


  system("cls");  //6-13-18 replaces clrscr() macro

  scanCnt = 0;

  if (pM201[bIndex]->tScan == 0)
  {
	 ccode = pM201[bIndex]->subChan + 3;		//setup location vars for display of
	 n = pM201[bIndex]->channel * 12 + 5;		//single channel voltages
	 SetChanCode(pM201[bIndex]);					//set control code for single channel scanning
  }

  StartScanning(pM201[bIndex]);  				//Start scanning using selected scan type

  system("cls");  //6-13-18 replaces clrscr() macro
  gotoxy(1, 1);
  printf(" CC    chan 0      chan 1      chan 2     ");
  printf(" chan 3      chan 4      chan 5\n\n");
  for(i=0;i<=15;i++)
  {
	 printf(" %d\n",i);
  }
  gotoxy(2,25);
  printf("Wait               Press any key to quit    ");
  printf("Scan interval %10.3lf secs",pM201[bIndex]->scanInterval);

SCANSTATUS:
  while(!kbhit())					//while no keystroke
  {

	//################################
	//3-11-02 ########################
	fQuickExitScan = FALSE;
	while(TRUE)
	{
		//received = (UINT)GetNumScansInBuffer();
		received = (UINT)GetNumScansInBuffer(pM201[bIndex]);

		//== For debugging ==========
		//static UINT uiCnt = 0; uiCnt++; gotoxy(2,23); printf("%u", uiCnt);

		if((received >= 1) || (received == 0xffffffff)) break;
		if(kbhit()) { fQuickExitScan = TRUE; break; }
	}
	if(fQuickExitScan) break;
	//3-11-02 ########################
	//################################



	 receiveError = GetOneScan(pM201[bIndex]);	//get one scan from comm
	 if (receiveError != 0)
	 {
		gotoxy(2,25);
		printf("SCAN # %ld", ++scanCnt);
		
		if(pM201[bIndex]->tScan == 0)
		{
		  gotoxy(n,ccode);
		  Gconv(pM201[bIndex]);				//get voltage
		  printf("%9.3lf", pM201[bIndex]->voltage);

		  if (logging)
		  {
			 fprintf(out,"%9.3lf  ", pM201[bIndex]->voltage);
		  }

		  if (logging)
		  {
			 fprintf(out,"\n");
		  }
		  goto SCANSTATUS;
		}
		
		if(pM201[bIndex]->tScan == 2)
		{
		  gotoxy(2,23);
		  printf("Offset cal ");
		  Gconv(pM201[bIndex]);				//get voltage
		  printf("   %9.3lf", pM201[bIndex]->voltage);

		  if (logging)
		  {
			 fprintf(out,"%9.3lf  ", pM201[bIndex]->voltage);
		  }

		  gotoxy(27,23);
		  printf("Full scale cal ");
		  Gconv(pM201[bIndex]);				//get voltage
		  printf("   %9.3lf", pM201[bIndex]->voltage);

		  if (logging)
		  {
			 fprintf(out,"%9.3lf  ", pM201[bIndex]->voltage);
		  }
		}
		

		for(n2 = 0; n2 <= 5; n2++)					//display channel voltages
		{
		  startCC = (int)(pM201[bIndex]->chan[n2] / 16);
		  endCC = cc[n2] + startCC - 1;

		  for(ccode=startCC;ccode<=endCC;ccode++)
		  {
			 gotoxy((n2 * 12) + 5,(ccode + 3));
			 Gconv(pM201[bIndex]);				//get voltage
			 printf("%9.3lf", pM201[bIndex]->voltage);

			 if (logging)
			 {
			  	fprintf(out,"%9.3lf  ", pM201[bIndex]->voltage);
			 }

		  }

		}

		if (logging)
		{
		   fprintf(out,"\n");
		}

		if(pM201[bIndex]->NewScanBuff[0] != 0x0F)			// should be end of scan token
		{
		   printf("End scan framing failure ");
		   getch();
		   goto END_SCANS;
		}

		RemFromBuffer(pM201[bIndex],1);		//remove end scan token
	 }
	 else
	 {
		gotoxy(2,19);
		if (pM201[bIndex]->errorType == 1)
		{
		  printf("Start scan framing failure\n");
		}

		if (pM201[bIndex]->errorType == 2)
		{
		  printf("not enough chars, possible communications error");
		}

		if (pM201[bIndex]->errorType == 3)
		{
		  printf("buffer overflow");
		}

		if (pM201[bIndex]->errorType == 0xA)
		{
		  printf("scan rate too fast for this scan type");
		}

		printf("\n press any key to continue");
		getch();

		goto END_SCANS;
	 }

  }									//end while !kbhit()
END_SCANS:
  if (logging)
  {
	 fclose(out);
  }

  gotoxy(1,25);
  printf("                    Wait                 ");

  while(kbhit())					//empty keyboard buffer
  {
	 getch();
  }


 StopScanning(pM201[bIndex]);					//Tell the Model 201 to stop scanning

 pM201[bIndex]->channel = tempCh;		  		//restore channel and subchannel
 pM201[bIndex]->subChan = tempSub;

 goto GET_SCANS;					//end of scanning example

EXIT_POINT:

	CloseDevice(pM201[bIndex]);					//close comm port
	UnloadLibraries();
	system("cls");  //6-13-18 replaces clrscr() macro
	printf("\nDo you wish to save configuration (y/n)?  ");
	Ch = getch();
	printf("\n");

	if (Ch == 'Y' || Ch == 'y')
	{

	  WriteConfig(&localAvg);
	}

	return 0;

}

//   Get starting & ending control codes for a scanning channel
short GetChannel(int value)
{
short channel;

startCC=-1;
endCC=-1; 

static char  tmpbuf1[80];

	while ((startCC < 0) || (startCC > 15))
	{
	  system("cls");  //6-13-18 replaces clrscr() macro
	  gotoxy(4,23);
	  printf( "Enter an end code smaller than the start code to skip this channel");

	  SetWin32CursorOn();
	  gotoxy(1,12);
	  printf("Channel number:    %d\n",value);
	  printf("Enter starting control code  ");
	  getch();    

	  tmpbuf1[1] = 0;
	  fgets(tmpbuf1,80,stdin);

	  if (tmpbuf1[1] >= '0')
	  {
		 startCC =  (short)((tmpbuf1[0] - '0')*10);
		 startCC += (short)(tmpbuf1[1] - '0');
	  }
	  else
	  {
		 startCC = (short)(tmpbuf1[0] - '0');
	  }

	}

	while ((endCC < 0) || (endCC > 15))
	{
	  printf("Enter ending control code  ");

	  getch();    
	  tmpbuf1[1] = 0;
	  fgets(tmpbuf1,80,stdin);
	  SetWin32CursorOff();

	  if (tmpbuf1[1] >= '0')
	  {
		 endCC =  (short)((tmpbuf1[0] - '0')*10);
		 endCC += (short)(tmpbuf1[1] - '0');
	  }
	  else
	  {
		 endCC = (short)(tmpbuf1[0] - '0');
	  }

	}

	if ( startCC > endCC)
	{
		startCC = 1;
		endCC = 0;
	}

	channel = (short)(startCC * 16 + endCC);
	return channel;
}


void PrintCommandMenu(int Ch, short localAvg, short checkSum)
{
int nn;

  gotoxy (10,1);
  printf ("POLLED  MENU   Lawson Labs Model 201   Version=%d\n", pM201[bIndex]->version);
  gotoxy (5,3);
  printf ("C) A/D input Channel    %d", pM201[bIndex]->channel);
  gotoxy (5,4);
  printf ("E) External sub-channel %d", pM201[bIndex]->subChan);

  if (pM201[bIndex]->subChan < 10)
  {
	 printf (" ");
  }

  gotoxy (5,5);
  printf ("A) remote Averaging     %d", pM201[bIndex]->average);
  gotoxy (5,6);
  printf ("L) Local averaging      %d        ", localAvg);
  gotoxy (5,7);

  printf ("T) filTer             ");
  if (pM201[bIndex]->filter == 0)
  {
	 printf ("  4 hz");
  }
  else if (pM201[bIndex]->filter == 1)
  {
	 printf (" 40 hz ");
  }
  else
  {
	 printf ("400 hz ");
  }

  gotoxy (5,8);
  printf ("G) Gain factor        %3d",pM201[bIndex]->gain);

  gotoxy (5,9);
  printf ("R) sample Rate       %6.1lf",pM201[bIndex]->rate);

  gotoxy (5,10);
  printf( "B) ");
  if (pM201[bIndex]->standBy)
  {
	 printf("in standBy mode    ");
  }
  else
  {
	 printf("out of standBy mode");
  }

  gotoxy (43,3); printf ("D) Digital inputs ");

  if (Ch == 'D')
  {
	 printf ("  %d",pM201[bIndex]->lastDigInp);

	 if (pM201[bIndex]->lastDigInp < 100)
	 {
		printf ("  ");
	 }

	 gotoxy (61,2); printf ("Decimal 76543210\n");
	 gotoxy (69,3);

	 for (nn = 7;nn != -1; nn--)
	 {

		if (pM201[bIndex]->lastDigInp&(int)(pow(2, nn)))
		{
		  printf ("1");
		}
		else
		{
		  printf ("0");
		}

	 }

  }

  gotoxy (43,4); printf ("U) digital oUtput   ");

  if (Ch == 'U')
  {
	 printf ("%d  ",pM201[bIndex]->digOutWord);
	 Ch = 0;
  }

  gotoxy (43,5); printf ("K) checKsum         ");

  if (Ch == 'K')
  {
	 if (checkSum)
	 {
		printf ("     OK");
	 }
	 else
	 {
		printf (" not OK");
	 }

  }
  else
  {
	 printf ("        ");
  }

  gotoxy (43,6);
  printf ("S) System calibration");
  gotoxy (43,7);
  printf ("O) Offset calibration");

  gotoxy (43,8);
  printf ("W) Word length      ");

  if (pM201[bIndex]->wordCnt == 3)
  {
	 printf("24 bits");
  }
  else
  {
	 printf("16 bits");
  }

  gotoxy (43,9);
  printf ("P) Polarity        ");

  if (pM201[bIndex]->biPolar)
  {
	 printf (" Bipolar");
  }
  else
  {
	 printf ("Unipolar");
  }

  gotoxy (43,10);
  printf ("Z) sleep");
  gotoxy(43,11);printf("X) Port=COM%d  ",pM201[bIndex]->comPort + 1);

  gotoxy (6,12); printf ("Counts      Millivolts\n");
  gotoxy (1,24);
  printf (" Press ESC for menu or space to reset max/min                       ");
}


void    StandardDev(double *stDv, double *rmsBits, double *sdTot,
					double *runningAvg, double *sd, int *sdCount)
{//standard deviation and RMS resolution calculation
	int i = 0, nnn,sdGrp=40, bits;
	double tempStDv;

	sd[*sdCount] = pM201[bIndex]->rawCount;
	(*sdTot) += pM201[bIndex]->rawCount;

	if ((*sdCount) == sdGrp)
	{
		(*stDv) = 0;
		(*sdTot) = (*sdTot) / sdGrp;

		for (nnn = 1; nnn != sdGrp; nnn++)
		{
			(*stDv) = (*stDv) + ((*sdTot) - sd[nnn])*((*sdTot) - sd[nnn]);
		}

		(*stDv) = sqrt((*stDv) / (sdGrp-1));
		tempStDv = (*stDv);

CALCNEXT:

		if (tempStDv >= 1)
		{
			i = i + 1;
			tempStDv = tempStDv / 2;
			goto CALCNEXT;
		}

		if (pM201[bIndex]->wordCnt == 3)
		{
			bits = 24;
		}
		else
		{
			bits = 16;
		}

		(*rmsBits) = bits - i;

		if ((tempStDv < .75) && (i != 0))
		{
			(*rmsBits) = (*rmsBits) + .5;
		}

		pM201[bIndex]->rawCount = (long)*sdTot;
		*runningAvg = Counts2Volts(pM201[bIndex]);

		pM201[bIndex]->rawCount = (long)*stDv;
		*stDv = Counts2Volts(pM201[bIndex]);

		if (pM201[bIndex]->biPolar)
		{
			(*stDv) += 5000;		//unipolar voltage range
		}

		(*sdTot) = 0; (*sdCount) = 1;
	}
	else
	{
		(*sdCount)++;
	}
}

void DoCommand(int Ch, double *max,	double *min,
					short *localAvg, short *checkSum)
{
char tempCh=0;
short tempSubChan, tempGain;
char tmpbuf[80];

  if (islower(Ch))
  {
	 Ch = toupper(Ch);
  }

  gotoxy (1,24);
  printf ("                                                   ");

  if (Ch == 'Z')
  {
	 pM201[bIndex]->sleeping = GotoSleep(pM201[bIndex]);
  }

  if (Ch == 'T')
  {

	 if(++pM201[bIndex]->filter == 3)
	 {
		pM201[bIndex]->filter = 0;
	 }

	 SetFilter(pM201[bIndex]);
  }

  if (Ch == 'R')
  {
	 SelectRate();
  }

  if (Ch == 'B')
  {

	 if(pM201[bIndex]->standBy)
	 {
		pM201[bIndex]->standBy = 0;
	 }
	 else
	 {
		pM201[bIndex]->standBy = 1;
	 }

	 SendADMode(pM201[bIndex]);
  }

  if (Ch == 'G')
  {
	 pM201[bIndex]->gain = (short)fmod(pM201[bIndex]->gain*2,255);
	 SendADMode(pM201[bIndex]);
  }

  if (Ch == 'P')
  {

	 if(pM201[bIndex]->biPolar)
	 {
		pM201[bIndex]->biPolar = 0;
	 }
	 else
	 {
		pM201[bIndex]->biPolar = 1;
	 }

	 SendADMode(pM201[bIndex]);

	 SysCal(pM201[bIndex]);

	 SetChanCode(pM201[bIndex]);

  }

  if (Ch == 'W')
  {
	 if(pM201[bIndex]->wordCnt == 2)
	 {
		pM201[bIndex]->wordCnt = 3;
	 }
	 else
	 {
		pM201[bIndex]->wordCnt = 2;
	 }

	 SendADMode(pM201[bIndex]);
  }

  if (Ch == 'A')
  {

	 while((tempCh != 27) && (tempCh != 13))
	 {

		while (!kbhit())
		{
		  gotoxy (1,24);
		  printf ( "Press + increase, - decrease averaging, Enter to continue ");
		  printf ( "%6d", pM201[bIndex]->average);
		}

		tempCh =(BYTE) getch();
		if (tempCh == '+')
		{
		  pM201[bIndex]->average *= 2;
		}

		if (tempCh == '-')
		{
		  pM201[bIndex]->average /= 2;
		}

		if (pM201[bIndex]->average  < 1)
		{
		  pM201[bIndex]->average = 32678;
		}
		else if (pM201[bIndex]->average > 32678)
		{
		  pM201[bIndex]->average = 1;
		}

	 }

	 RemoteAvg(pM201[bIndex]);
  }

  if (Ch == 'C')
  {
	 tempCh = -1;

	 while ((tempCh < '0') || (tempCh > '7'))
	 {
		gotoxy(1,24);
		printf("Enter channel ");
		tempCh =(BYTE)getche();
	 }

	 pM201[bIndex]->channel = (short)(tempCh - '0');

	 SetChanCode(pM201[bIndex]);
	 gotoxy(1,24);
    printf("                       waiting filter settling time...");
	 FilterDelay(pM201[bIndex]);

  }

  if (Ch == 'D')
  {
	 GetDigIn(pM201[bIndex]);
  }

  if (Ch == 'E')
  {
	 tempSubChan = -1;

	 while ((tempSubChan < 0) || (tempSubChan > 15))
	 {
	   SetWin32CursorOn();
		gotoxy(1,24);
		printf("Enter sub channel ");
		getch();    
		tmpbuf[1] = 0;
		fgets(tmpbuf,80,stdin);
		SetWin32CursorOff();

		if (tmpbuf[1] >= '0')
		{
		  tempSubChan =  (short)((tmpbuf[0] - '0')*10);
		  tempSubChan += (short)(tmpbuf[1] - '0');
		}
		else
		{
		  tempSubChan = (short)(tmpbuf[0] - '0');
		}

	 }

	 pM201[bIndex]->subChan = tempSubChan;

	 SetChanCode(pM201[bIndex]);

	 system("cls");  //6-13-18 replaces clrscr() macro  
	 gotoxy(1,24);
     printf("                       waiting filter settling time...");
	 FilterDelay(pM201[bIndex]);

  }

  if (Ch == 'L')
  {
	 (*localAvg) = 0;
	 SetWin32CursorOn();

	 while ((*localAvg) < 1)
	 {
		gotoxy(1,24);
		printf("Enter local averaging ");
		getch();    
		fgets(tmpbuf,80,stdin);
		sscanf(tmpbuf,"%d",localAvg);
	 }

	 SetWin32CursorOff();

  }

  if (Ch == 'K')
  {
	 (*checkSum) = GetCheckSum(pM201[bIndex]);
  }

  if (Ch == 'S')
  {
	 gotoxy(31,24);
	 printf("Calibrating...");
	 tempCh = (BYTE)pM201[bIndex]->channel;
	 tempGain = pM201[bIndex]->gain;
	 if (pM201[bIndex]->gain != 1)
	 {
		pM201[bIndex]->gain = 1;
		SendADMode(pM201[bIndex]);
	 }

	 SysCal(pM201[bIndex]);

	 if (tempGain != 1)
	 {
		pM201[bIndex]->gain = tempGain;
		SendADMode(pM201[bIndex]);

		pM201[bIndex]->channel = 7;
		OffsetCal(pM201[bIndex]);
	 }

	 pM201[bIndex]->channel=tempCh;
	 SetChanCode(pM201[bIndex]);

	 FilterDelay(pM201[bIndex]);

  }

  if (Ch == 'O')
  {
	 gotoxy(31,24);
	 printf("Calibrating...");
	 OffsetCal(pM201[bIndex]);
  }

  if (Ch == 'F')
  {
	 gotoxy(31,24);
	 printf("Calibrating...");
	 FullScaleCal(pM201[bIndex]);
  }

  if (Ch == 'U')
  {
	 pM201[bIndex]->digOutWord = -1;
	 SetWin32CursorOn();

	 while ((pM201[bIndex]->digOutWord < 0) || (pM201[bIndex]->digOutWord > 255))
	 {
		gotoxy(1,24);
		printf ("Enter Output Code ");
		getch();    
		fgets(tmpbuf,80,stdin);
		sscanf(tmpbuf,"%d",&pM201[bIndex]->digOutWord);
	 }

	 SetWin32CursorOff();
	 SetDigOut(pM201[bIndex],pM201[bIndex]->digOutWord);
  }

  if (Ch == ' ')
  {
	 (*max) = -12000.0;
	 (*min) = 12000.0;				//reset max-min
  }
  if(!pM201[bIndex]->sleeping)
  {
	 PrintCommandMenu(Ch, (*localAvg), (*checkSum));
  }

}


short ScanMenu()					//displays the scanning menu (returns 1 if
									//set to start scanning
{
int Ch, n, vala;
short	i;

char tmpbuf[80];

SCANMENU1:  
  system("cls");  //6-13-18 replaces clrscr() macro
  pM201[bIndex]->numChannels = 0;

  for (n= 0;n<=5;n++)				//initialize control code array
  {
	 cc[n] = (pM201[bIndex]->chan[n] & 0x0f) - (pM201[bIndex]->chan[n]>>4) + 1;  
	 pM201[bIndex]->numChannels += cc[n];		//figure total number of channels/scan
  }
  gotoxy(27,1);
  printf("SCANNING  CONFIGURATION");
  gotoxy(14,3);
  printf("CHANNEL      EXTERNAL CONTROL CODE      NUMBER OF");
  gotoxy(54,4);
  printf("DATA POINTS");

  if(pM201[bIndex]->tScan == 0)
  {
	 pM201[bIndex]->subChan = (short)(pM201[bIndex]->singleChan&15);
	 pM201[bIndex]->channel = (short)(pM201[bIndex]->singleChan>>4);
	 gotoxy(18,7);
	 printf ("%d",pM201[bIndex]->channel);
	 printf("               %d                 1", pM201[bIndex]->subChan);
	 gotoxy(15,10);
	 printf("   PRESS 0 - 5 FOR CHANNEL");
  }
  else
  {
	 gotoxy(29,5);
	 printf("FROM           TO        THIS CHANNEL");

	 for (n=0;n<=5;n++)
	 {
		gotoxy(17,7 + n * 2);
		printf("%d)           ", n);
		printf( "%2d            %2d           %2d",pM201[bIndex]->chan[n]>>4, (int)fmod((double)pM201[bIndex]->chan[n],16), cc[n]);
	 }
  }

  gotoxy(17,19);
  printf("6) Scan Interval  %11.4lf seconds",pM201[bIndex]->scanInterval);

  if((pM201[bIndex]->gain != 1) && (pM201[bIndex]->tScan == 2))
  {
	 pM201[bIndex]->tScan = 0;				//no cal scan unless gain=1
  }

  gotoxy(17,21);
  printf("7) Scan type: ");

  if (pM201[bIndex]->tScan == 0)
  {
	 printf ("Single Channel  ");
  }
  else if (pM201[bIndex]->tScan == 1)
  {
	 printf ("Normal          ");
  }
  else
  {
	 printf ("Self-Calibration");
  }

  gotoxy(11,23);
  printf("  Enter) Perform the scan");
  gotoxy(15,24);
  printf("Esc) To continue");

  if(pM201[bIndex]->tScan > 0)
  {
	 printf("         data points per scan  %d",pM201[bIndex]->numChannels);
  }
  gotoxy(60,1);
  printf("X) M201 at COM%d",pM201[bIndex]->comPort + 1);

  Ch = getch();
  if(Ch == 'X' || Ch =='x'){
		bIndex ++;
		if(pM201[bIndex] == NULL){bIndex = 0;}
		goto SCANMENU1;
  }
  vala = Ch -'0';

  if((vala == 0) && (Ch != '0'))
  {
	 vala = 10;						//flag invalid keystroke
  }

  if((vala >= 0) && (vala <= 5))
  {

	 if (pM201[bIndex]->tScan == 0)
	 {
		system("cls");  //6-13-18 replaces clrscr() macro
		gotoxy(10,12);
		printf("Channel number:    %d",vala);

		SetWin32CursorOn();
		gotoxy(10,14);
		printf ("Enter external control code, 0 - 15 ");
		getch();    
		fgets(tmpbuf,80,stdin);
		sscanf(tmpbuf,"%d",&pM201[bIndex]->subChan);
		SetWin32CursorOff();

		pM201[bIndex]->subChan = (short)fmod((double)pM201[bIndex]->subChan,16.0);
		pM201[bIndex]->channel =(short)vala;
		pM201[bIndex]->singleChan =(short)((vala<<4) +  pM201[bIndex]->subChan);
	 }
	 else
	 {
		pM201[bIndex]->chan[vala] = GetChannel(vala);
	 }

  }

  if(vala == 6)
  {
	 i = CheckScanTime(pM201[bIndex],&maxTime, &minTime);
	 CalcScanTime();
  }

  if(vala == 7)
  {

	 if (pM201[bIndex]->tScan == 0)
	 {
		pM201[bIndex]->tScan = 1;
	 }
	 else if (pM201[bIndex]->tScan == 1)
	 {
		pM201[bIndex]->tScan = 2;
	 }
	 else
	 {
		pM201[bIndex]->tScan = 0;
	 }

	 if (pM201[bIndex]->gain != 1 && pM201[bIndex]->tScan == 2)
	 {
		pM201[bIndex]->tScan = 0;
	 }

  }

  if(Ch == 13)
  {

	 if(pM201[bIndex]->numChannels == 0)
	 {
		printf("You must enter control codes first, press any key to continue");
		getch();
		goto SCANMENU1;

	 }

	 i = CheckScanTime(pM201[bIndex],&maxTime, &minTime);

	 if (i==2)
	 {
		 printf("Reduced averaging to %d- Press any key to continue",pM201[bIndex]->average);
		 getch();
	 }
	 else if(!i)
	 {
		system("cls");  //6-13-18 replaces clrscr() macro
		gotoxy(10,15);
		printf("Scan time out of limits, press any key to continue");
		getch();
		CalcScanTime();
	 }

	 return 1;
  }

  if(Ch == 27)
  {
	 return 0;
  }

  goto SCANMENU1;

}


/****************************************************************************
Because all aspects of the scanning function of the Model 201 is programmable,
it can be difficult to determine what the optimal settings are for any
particular task. Also, if the A/D is not performing as intended, it can be
hard to determine the cause. An overview of how to set up the 201 from a
programmer's perspective follows.

The A/D is constantly performing conversions at DATARATE. This rate is set in
the mode registers of the A/D chip itself. Slower DATARATEs provide lower
noise, higher DATARATEs allow higher frequencies to be seen, and allow more
data points to be taken in the same time period.

For higher frequency applications the DATARATE should be set for the
appropriate low-pass filter cutoff frequency. The cutoff frequency is
approximately one quarter the DATARATE.

For DC and very low frequency applications, you would normally select the
lowest possible DATARATE. That lowest rate is determined by all the
programmable scanning variables - scan type, the number of channels scanned,
averaging, filter setting, word length and BAUD rate. Even though the
DATARATE is actually sent to the A/D before the rest of the scanning details
during the sign-on process, it should be calculated last. Details for Model
201 follow:


  pM201[bIndex]->baud           = 0 for 9600, 1 for 4800, etc.
  pM201[bIndex]->numChannels    = number of channels to scan
  pM201[bIndex]->average        = number of conversions to average
								(1, 2, 4, 8, 16, 32 etc)
  pM201[bIndex]->wordCnt        = number of bytes in conversion ( 2 or 3)
  pM201[bIndex]->filter;		  = 0 = 4 Hz, 1 = 40 Hz, 2 = 400 Hz filter

  For the Model 201, fTime is based on the pM201[bIndex]->filter setting:
	 0 (4 Hz), fTime = 4.5 seconds
	 1 (40 Hz), fTime = .56 seconds
	 2 (400 Hz), fTime = .036 seconds

Here, we have solved for the minimum sample rate given the scan interval:

  minSampleRate = (pM201[bIndex]->average + 2) / ((pM201[bIndex]->scanInterval - (pM201[bIndex]->wordCnt *
				 .002333) * 2 ^ pM201[bIndex]->baud) / pM201[bIndex]->numChannels - (fTime * .82));

A 5 percent margin should provide comfort. The following line would take
care of that:

  pM201[bIndex]->rate = 1.05 * minSampleRate;
****************************************************************************/
short CalcScanTime()	//select the scan interval
{

char tmpbuf[80];

short i;

  system("cls");  //6-13-18 replaces clrscr() macro

CALCSCANTIME1:

  if(pM201[bIndex]->numChannels == 0)
  {
	 printf("You must enter control codes first, press any key to continue");
	 getch();
	 return 0;
  }

  if (i==2)
  {
	 printf("Reduced averaging to %d- Press any key to continue",pM201[bIndex]->average);
	 getch();
  }

  SetWin32CursorOn();
  gotoxy(10,10);
  printf("Enter scan time ");
  printf("%10.4lf  - ", minTime);
  printf( "%12.4lf  seconds  ", maxTime);
  getch();   
  fgets(tmpbuf,80,stdin);
  sscanf(tmpbuf,"%lf",&pM201[bIndex]->scanInterval);

  SetWin32CursorOff();

  i = CheckScanTime(pM201[bIndex],&maxTime, &minTime);

  if (i==2)
  {
	 printf("Reduced averaging to %d- Press any key to continue",pM201[bIndex]->average);
	 getch();
  }
  else if(!i)
  {
	 system("cls");  //6-13-18 replaces clrscr() macro
	 gotoxy(10,15);
	 printf("Scan time out of limits, press any key to continue");
	 getch();
	 goto CALCSCANTIME1;
  }

  return 1;
}

void SelectRate()						//select the sampling rate for the A/D
{
char tmpbuf[80];

  SetWin32CursorOn();
  gotoxy(1,24);
  printf("            Enter sample rate between 10 and 1027  ");
  getch();    
  fgets(tmpbuf,80,stdin);
  sscanf(tmpbuf,"%f",&pM201[bIndex]->rate);
  SetWin32CursorOff();

  if (pM201[bIndex]->rate > 1027)
  {
	 pM201[bIndex]->rate = 1027;
  }
  else if (pM201[bIndex]->rate < 10)
  {
	 pM201[bIndex]->rate = 10;
  }

  SendADMode(pM201[bIndex]);

  SysCal(pM201[bIndex]);

  SetChanCode(pM201[bIndex]);

  system("cls");  //6-13-18 replaces clrscr() macro
}



// FOR TESTING ONLY
void TempCfg(void)
{
	//T_M201 *pM201[256];
    //m_M201Struct[0] = new M201Struct;
    pM201[bIndex]->TXQUEUESIZE = 1;
    pM201[bIndex]->RXQUEUESIZE = 1024;
    pM201[bIndex]->baud = 0;
    pM201[bIndex]->comPort = 1;
    pM201[bIndex]->filter = 2;
    pM201[bIndex]->gain = 1;
    pM201[bIndex]->rate = 10;
    pM201[bIndex]->wordCnt = 3;
    pM201[bIndex]->biPolar = 1;
    pM201[bIndex]->average = 1;
    pM201[bIndex]->scanInterval = 2;
    pM201[bIndex]->numChannels = 2;
    pM201[bIndex]->chan[0]= 0;
    pM201[bIndex]->chan[1]= 0;
    pM201[bIndex]->chan[2]= 16;
    pM201[bIndex]->chan[3]= 16;
    pM201[bIndex]->chan[4]= 16;
    pM201[bIndex]->chan[5]= 16;
    pM201[bIndex]->singleChan = 0;
    pM201[bIndex]->tScan = 1;
    pM201[bIndex]->channel = 0;
    pM201[bIndex]->subChan = 0;
    pM201[bIndex]->sleeping = 0;			// Set to awake
    pM201[bIndex]->standBy = 0;			// Set to not in standby
    pM201[bIndex]->timeBaseCnt = -1;
    pM201[bIndex]->lastDigInp = 0;
    pM201[bIndex]->modeRegLo = 195;
    pM201[bIndex]->modeRegMid = 128; 
    pM201[bIndex]->modeRegHi = 0;
}















short ReadConfig(short *localAvg)
{
char tmpbuf[80];
FILE *rCfg;

	if ((rCfg = fopen("201ewin.cfg", "rt")) != NULL)
	{
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->TXQUEUESIZE);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->RXQUEUESIZE);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->baud);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->comPort);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%lf",&pM201[bIndex]->scanInterval);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->numChannels);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->average);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->tScan);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->chan[0]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->chan[1]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->chan[2]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->chan[3]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->chan[4]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->chan[5]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->singleChan);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->channel);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->subChan);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->wordCnt);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->biPolar);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->filter);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->gain);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%f",&pM201[bIndex]->rate);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->modeRegLo);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->modeRegMid);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",&pM201[bIndex]->modeRegHi);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%d",localAvg);
	  fclose(rCfg);

		//5-8-01 temp
		// FOR TESTING ONLY TempCfg();



	  return 1;
	}
	else
	{
	  pM201[bIndex]->TXQUEUESIZE = 1;
	  pM201[bIndex]->RXQUEUESIZE = 1024;
	  pM201[bIndex]->baud = 0;
	  pM201[bIndex]->comPort = 0;
	  pM201[bIndex]->filter = 2;
	  pM201[bIndex]->gain = 1;
	  pM201[bIndex]->rate = 10;
	  pM201[bIndex]->wordCnt = 3;
	  pM201[bIndex]->biPolar = 1;
	  pM201[bIndex]->average = 1;
	  pM201[bIndex]->scanInterval = 2;
	  pM201[bIndex]->numChannels = 6;
	  pM201[bIndex]->chan[0]= 0;
	  pM201[bIndex]->chan[1]= 0;
	  pM201[bIndex]->chan[2]= 0;
	  pM201[bIndex]->chan[3]= 0;
	  pM201[bIndex]->chan[4]= 0;
	  pM201[bIndex]->chan[5]= 0;
	  pM201[bIndex]->singleChan = 0;
	  pM201[bIndex]->tScan = 1;
	  pM201[bIndex]->channel = 0;
	  pM201[bIndex]->subChan = 0;
	  (*localAvg) = 1;
	  return 0;
	}

}


short WriteConfig(short *localAvg)
{
FILE *wCfg;

  if ((wCfg = fopen("201ewin.cfg", "wt")) != NULL)
  {
	 fprintf(wCfg,"%d\n",pM201[bIndex]->TXQUEUESIZE);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->RXQUEUESIZE);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->baud);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->comPort);
	 fprintf(wCfg,"%lf\n",pM201[bIndex]->scanInterval);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->numChannels);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->average);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->tScan);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->chan[0]);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->chan[1]);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->chan[2]);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->chan[3]);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->chan[4]);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->chan[5]);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->singleChan);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->channel);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->subChan);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->wordCnt);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->biPolar);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->filter);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->gain);
	 fprintf(wCfg,"%f\n",pM201[bIndex]->rate);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->modeRegLo);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->modeRegMid);
	 fprintf(wCfg,"%d\n",pM201[bIndex]->modeRegHi);
	 fprintf(wCfg,"%d\n",(*localAvg));
	 fclose(wCfg);
	 return 1;
  }

  return 0;

}

void SetWin32CursorOn(void)
{
	ConsoleCursorInfo.bVisible = TRUE;
	SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
}

void SetWin32CursorOff(void)
{
	ConsoleCursorInfo.bVisible = FALSE;
	SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
}

BOOLEAN
LoadLibraries()
{
    hLibM201 = LoadLibrary ("NT_m201x.dll");
    if(!hLibM201)
	{
		MessageBox(0, "Error loading NT_m201x.DLL", "-- error", MB_OK);
		return FALSE;
	}
	return TRUE;
}

BOOLEAN
UnloadLibraries()
{
	FreeLibrary(hLibM201);
    hLibM201 = NULL;
	return TRUE;
}

//==== CHECKLIBFUNCS FUNCTION =================================================
BOOLEAN
CheckLibFuncs()
{
	BOOLEAN Status = TRUE;


	//#######################################
	//12-51-02 ## START ######################
    GetNumScansInBuffer = (DLL_GET_SCAN_PNT_CNT)GetProcAddress(hLibM201, "GetNumScansInBuffer");
    if(!GetNumScansInBuffer)
    {
        MessageBox(0, "failed to find function:\n     GetNumScansInBuffer()"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }

    GetNumBytesInBuffer = (DLL_GET_SCAN_BYTE_CNT)GetProcAddress(hLibM201, "GetNumBytesInBuffer");
    if(!GetNumBytesInBuffer)
    {
        MessageBox(0, "failed to find function:\n     GetNumBytesInBuffer()"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
	//12-51-02 ## END ########################
	//#######################################





    SignOn = (DLL_SIGN_ON)GetProcAddress(hLibM201, "SignOn");
    if(!SignOn)
    {
        MessageBox(0, "failed to find function:\n     SignOn()"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    RemoteAvg = (DLL_REMOTE_AVG)GetProcAddress(hLibM201, "RemoteAvg");
    if(!RemoteAvg)
    {
        MessageBox(0, "failed to find function:\n     RemoteAvg(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    Counts2Volts = (DLL_COUNTS_2_VOLTS)GetProcAddress(hLibM201, "Counts2Volts");
    if(!Counts2Volts)
    {
        MessageBox(0, "failed to find function:\n     Counts2Volts(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetDigIn = (DLL_GET_DIG_IN)GetProcAddress(hLibM201, "GetDigIn");
    if(!GetDigIn)
    {
        MessageBox(0, "failed to find function:\n     GetDigIn(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetVer = (DLL_GET_VER)GetProcAddress(hLibM201, "GetVer");
    if(!GetVer)
    {
        MessageBox(0, "failed to find function:\n     GetVer(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    SetDigOut = (DLL_SET_DIG_OUT)GetProcAddress(hLibM201, "SetDigOut");
    if(!SetDigOut)
    {
        MessageBox(0, "failed to find function:\n     SetDigOut(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    FullScaleCal = (DLL_FULL_SCALE_CAL)GetProcAddress(hLibM201, "FullScaleCal");
    if(!FullScaleCal)
    {
        MessageBox(0, "failed to find function:\n     FullScaleCal(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    OffsetCal = (DLL_OFFSET_CAL)GetProcAddress(hLibM201, "OffsetCal");
    if(!OffsetCal)
    {
        MessageBox(0, "failed to find function:\n     OffsetCal(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    SysCal = (DLL_SYS_CAL)GetProcAddress(hLibM201, "SysCal");
    if(!SysCal)
    {
        MessageBox(0, "failed to find function:\n     SysCal(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetConversion = (DLL_GET_CONVERSION)GetProcAddress(hLibM201, "GetConversion");
    if(!GetConversion)
    {
        MessageBox(0, "failed to find function:\n     GetConversion(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    SetChanCode = (DLL_SET_CHAN_CODE)GetProcAddress(hLibM201, "SetChanCode");
    if(!SetChanCode)
    {
        MessageBox(0, "failed to find function:\n     SetChanCode(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    StartScanning = (DLL_START_SCANNING)GetProcAddress(hLibM201, "StartScanning");
    if(!StartScanning)
    {
        MessageBox(0, "failed to find function:\n     StartScanning(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetOneScan = (DLL_GET_ONE_SCAN)GetProcAddress(hLibM201, "GetOneScan");
    if(!GetOneScan)
    {
        MessageBox(0, "failed to find function:\n     GetOneScan(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    StopScanning = (DLL_STOP_SCANNING)GetProcAddress(hLibM201, "StopScanning");
    if(!StopScanning)
    {
        MessageBox(0, "failed to find function:\n     StopScanning(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    Gconv = (DLL_GCONV)GetProcAddress(hLibM201, "Gconv");
    if(!Gconv)
    {
        MessageBox(0, "failed to find function:\n     Gconv(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    RemFromBuffer = (DLL_REMOVE_FROM_BUFFER)GetProcAddress(hLibM201, "RemFromBuffer");
    if(!RemFromBuffer)
    {
        MessageBox(0, "failed to find function:\n     RemFromBuffer(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    SetFilter = (DLL_SET_FILTER)GetProcAddress(hLibM201, "SetFilter");
    if(!SetFilter)
    {
        MessageBox(0, "failed to find function:\n     SetFilter(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    SendADMode = (DLL_SEND_AD_MODE)GetProcAddress(hLibM201, "SendADMode");
    if(!SendADMode)
    {
        MessageBox(0, "failed to find function:\n     SendADMode(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetCheckSum = (DLL_GET_CHECK_SUM)GetProcAddress(hLibM201, "GetCheckSum");
    if(!GetCheckSum)
    {
        MessageBox(0, "failed to find function:\n     GetCheckSum(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    CloseDevice = (DLL_CLOSE_DEVICE)GetProcAddress(hLibM201, "CloseDevice");
    if(!CloseDevice)
    {
        MessageBox(0, "failed to find function:\n     CloseDevice(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GotoSleep = (DLL_GOTO_SLEEP)GetProcAddress(hLibM201, "GotoSleep");
    if(!GotoSleep)
    {
        MessageBox(0, "failed to find function:\n     GotoSleep(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    FilterDelay = (DLL_FILTER_DELAY)GetProcAddress(hLibM201, "FilterDelay");
    if(!FilterDelay)
    {
        MessageBox(0, "failed to find function:\n     FilterDelay(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    CheckScanTime = (DLL_CHECK_SCAN_TIME)GetProcAddress(hLibM201, "CheckScanTime");
    if(!CheckScanTime)
    {
        MessageBox(0, "failed to find function:\n     CheckScanTime(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetComHandle = (DLL_GET_COM_HANDLE)GetProcAddress(hLibM201, "GetComHandle");
    if(!GetComHandle)
    {
        MessageBox(0, "failed to find function:\n     GetComHandle(...)"
                "\nin NT_m201x.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
	return Status;
}


